using System.IO;

public class RegisterScriptMenu
{

    [DeclareMenu()]
    public void MenuFunction()
    {
        Eplan.EplApi.Gui.Menu oMenu = new Eplan.EplApi.Gui.Menu();
        oMenu.AddMenuItem("Doc Folder",
        				"OpenProjectDoccFolderInExplorerAction",
        				"Opens the document folder of the current selected project",
						System.UInt32.Parse("35032"), 	// ID of the previous menu
						System.Int32.Parse("0"), 	// ID of the following menu. (0 for default)
						false,
						true);
    }
    
	[Start]
	[DeclareAction("OpenProjectDoccFolderInExplorerAction")]
	public void MyFunctionAsAction()
	{

		Eplan.EplApi.ApplicationFramework.ActionManager oMngr = new Eplan.EplApi.ApplicationFramework.ActionManager();
		Eplan.EplApi.ApplicationFramework.Action oSelSetAction = oMngr.FindAction("selectionset");
		string sProjectFolder = string.Empty;
		if (oSelSetAction != null)
		{
		Eplan.EplApi.ApplicationFramework.ActionCallingContext ctx = new Eplan.EplApi.ApplicationFramework.ActionCallingContext();
		ctx.AddParameter("TYPE", "PROJECT");
		bool bRet = oSelSetAction.Execute(ctx);
		if (bRet)
		{
			string selectedProject = string.Empty;
			ctx.GetParameter("PROJECT", ref selectedProject);
			sProjectFolder =  selectedProject.Replace(".elk",".edb");
		}
		else
		{
			System.Windows.Forms.MessageBox.Show("Execution of the Action selectionset failed!");
		}
		}
		else
		{
		System.Windows.Forms.MessageBox.Show("Action selectionset was not found!");
		}

		//string docPath = sProjectFolder + "\\..";
		//System.Diagnostics.Process.Start("explorer.exe", docPath);
		//System.Windows.Forms.MessageBox.Show("explorer \"" + sProjectFolder + "\\.." + "\"" );
		
		string dpath = ParseProjectInfoXML(sProjectFolder,"\"Benutzer Zusatzfeld 5\"");
//		System.Windows.Forms.MessageBox.Show("explorer \"" + dpath + "\"" );
		System.Diagnostics.Process.Start("explorer.exe", dpath);

    }

    public string ParseProjectInfoXML(string prjpath, string search)
    {
	string xmlfile = prjpath + "/" + "ProjectInfo.xml"; // path to the xml file
	string val = string.Empty; // the value to return
	
	StreamReader s = File.OpenText(xmlfile);
	string read = null;
	int F1;
	int F2;

	while ((read = s.ReadLine()) != null)
	{
	  if (read.IndexOf(search) > -1 ) {
		//System.Windows.Forms.MessageBox.Show("gefunden \"" + search + "\" in \"" + read + "\"" );
		F1=read.IndexOf(">");
		F2=read.LastIndexOf("<");
		//System.Windows.Forms.MessageBox.Show("pos f1: " + F1 + ", Pos f2: " + F2);
		val=read.Substring(F1+1,F2-F1-1);
		// remove language definition @ and
		if ( val.IndexOf("@") > -1 ) {
				F1=val.IndexOf("@");
				F2=val.LastIndexOf(";");
				val=val.Substring(F1+1,F2-F1-1);
		}
	  }
	}
	s.Close();
	return val;
    }
}
